import peasy.*;
PeasyCam cam;

import controlP5.*;
ControlP5 countries;
CheckBox checkCountries;

Table table;
int numRows;

int frameLength = 1000;
int[] dewey,checkouts,copies;
String[] keyword,title,deweyType;

float[] transCheckouts;

PShape circles;
PShape arcs;
PShape lines;

PFont font;

int fillTransplantCircle = 80;
int strokeTransplantCircle = 30;
int fillTransplantArc = 60;
int strokeTransplantArc = 50;

void setup(){
  size(1280,800,P3D);
  cam = new PeasyCam(this, width/2, height/2, 0, 1000);
  
//  countries = new ControlP5(this);
//  checkCountries = countries.addCheckBox("checkBox")
//                  .setPosition(20, 20)
//                  .setColorForeground(color(120))
//                  .setColorActive(color(255))
//                  .setColorLabel(color(0))
//                  .setSize(10, 10)
//                  .setItemsPerRow(1)
//                  .setSpacingRow(3)
//                  .addItem("America", 0)
//                  .addItem("China", 1)
//                  .addItem("Germany", 2)
//                  .addItem("India", 3)
//                  .addItem("Korea", 4)
//                  .addItem("Mexico", 5)
//                  ;
//  countries.setAutoDraw(false);
  
  circles = createShape(GROUP);
  arcs = createShape(GROUP);
  lines = createShape(GROUP);
  
  font = loadFont("AvenirNext-UltraLight-24.vlw");
  textFont(font,10);
  
  //get data
  table = loadTable("countries3.csv");
  numRows = table.getRowCount();
  
  dewey = new int[numRows-1];
  checkouts = new int[numRows-1];
  copies = new int[numRows-1];
  keyword = new String[numRows-1];
  title = new String[numRows-1];
  transCheckouts = new float[numRows-1];
  deweyType = new String[10];
  
  for(int i=0; i<numRows-1; i++){
    keyword[i] = table.getString(i+1,0);
    title[i] = table.getString(i+1,1);
    copies[i] = table.getInt(i+1,2);
    checkouts[i] = table.getInt(i+1,3);
    dewey[i] = table.getInt(i+1,4); 
  }
  //get data
  
  //drawing everything
  for(int i=0; i<numRows-1; i++){
    transCheckouts[i] = map(checkouts[i],0,4500,0,1000);
    PShape ellipse = createShape(ELLIPSE,dewey[i]-copies[i]/2,transCheckouts[i]-copies[i]/2,copies[i],copies[i]);
    PShape line = createShape(LINE,dewey[i],0,dewey[i],copies[i]*5);
    line.rotateX(-PI/2);
    line.setStroke(color(100));
    line.translate(0,0,transCheckouts[i]);
    
    if(keyword[i].equals("China") == true || keyword[i].equals("china") == true){
      ellipse.setFill(color(#A52B2B,fillTransplantCircle));
      ellipse.setStroke(color(#A52B2B,strokeTransplantCircle));
    }
    if(keyword[i].equals("Germany") == true || keyword[i].equals("germany") == true){
      ellipse.setFill(color(#EAE76F,fillTransplantCircle));
      ellipse.setStroke(color(#EAE76F,strokeTransplantCircle));
    }
    if(keyword[i].equals("America") == true || keyword[i].equals("america") == true){
      ellipse.setFill(color(#050FB4,fillTransplantCircle));
      ellipse.setStroke(color(#050FB4,strokeTransplantCircle));
    }
    if(keyword[i].equals("Mexico") == true || keyword[i].equals("mexico") == true){
      ellipse.setFill(color(#0A8B2D,fillTransplantCircle));
      ellipse.setStroke(color(#0A8B2D,strokeTransplantCircle));
    }
    if(keyword[i].equals("India") == true || keyword[i].equals("india") == true){
      ellipse.setFill(color(#DE8714,fillTransplantCircle));
      ellipse.setStroke(color(#DE8714,strokeTransplantCircle));
    }
    if(keyword[i].equals("Korea") == true || keyword[i].equals("korea") == true){
      ellipse.setFill(color(#9A14DE,fillTransplantCircle));
      ellipse.setStroke(color(#9A14DE,strokeTransplantCircle));
    }
    circles.addChild(ellipse);
    lines.addChild(line);
   
   //drawing arcs
    if(i>0 && keyword[i].equals(keyword[i-1]) == true){
      float xMove = (dewey[i]+dewey[i-1])/2;
      float yMove = (transCheckouts[i]+transCheckouts[i-1])/2;
      float xSide = dewey[i]-dewey[i-1];
      float ySide = transCheckouts[i]-transCheckouts[i-1];
      float dist = dist(dewey[i],transCheckouts[i],dewey[i-1],transCheckouts[i-1]);
       
      PShape arc = createShape(ARC,-dist/2,-dist/2,dist,dist,0,PI);
      arc.translate(xMove,yMove,0);
      arc.rotateZ(atan(ySide/xSide));
      arc.rotateX(PI/2);
       
      if(keyword[i].equals("China") == true || keyword[i].equals("china") == true){
        arc.setFill(color(#A52B2B,fillTransplantArc));
        arc.setStroke(color(#A52B2B,strokeTransplantArc));
      }
      if(keyword[i].equals("Germany") == true || keyword[i].equals("germany") == true){
        arc.setFill(color(#EAE76F,fillTransplantArc));
        arc.setStroke(color(#EAE76F,strokeTransplantArc));
      }
      if(keyword[i].equals("America") == true || keyword[i].equals("america") == true){
        arc.setFill(color(#050FB4,fillTransplantArc));
        arc.setStroke(color(#050FB4,strokeTransplantArc));
      }
      if(keyword[i].equals("Mexico") == true || keyword[i].equals("mexico") == true){
        arc.setFill(color(#0A8B2D,fillTransplantArc));
        arc.setStroke(color(#0A8B2D,strokeTransplantArc));
      }
      if(keyword[i].equals("India") == true || keyword[i].equals("india") == true){
        arc.setFill(color(#DE8714,fillTransplantArc));
        arc.setStroke(color(#DE8714,strokeTransplantArc));
      }
      if(keyword[i].equals("Korea") == true || keyword[i].equals("korea") == true){
        arc.setFill(color(#9A14DE,fillTransplantArc));
        arc.setStroke(color(#9A14DE,strokeTransplantArc));
      }
       arcs.addChild(arc);
     }
     //drawing arcs
  }
 //drawing everything
 
  for(int i=0;i<10;i++){      
        if(i == 9){
          deweyType[i] = "History & Geography";
        }
        if(i == 8){
          deweyType[i] = "Literature";
        }
        if(i == 7){
          deweyType[i] = "Arts & Recreation";
        }
        if(i == 6){
          deweyType[i] = "Technology";
        }
        if(i == 5){
          deweyType[i] = "Pure Science";
        }
        if(i == 4){
          deweyType[i] = "Language";
        }
        if(i == 3){
          deweyType[i] = "Social Sciences";
        }
        if(i == 2){
          deweyType[i] = "Religion";
        }
        if(i == 1){
          deweyType[i] = "Philosophy and Psychology";
        }
        if(i == 0){
          deweyType[i] = "General, CS & Info";
        }
  }
}

void draw(){
  background(255);
  
  //drawing the base
  beginShape();
  stroke(0,50);
  noFill();
  vertex(0,0,0);
  vertex(0,frameLength+100,0);
  vertex(frameLength,frameLength+100,0);
  vertex(frameLength,0,0);
  endShape();
  //drawing the base
  lights();
  hint(DISABLE_DEPTH_TEST);
  shape(circles);
  shape(arcs);
  shape(lines);
  hint(ENABLE_DEPTH_TEST);
  
  //image(texts,0,0);
  textFont(font,8);
  for(int i=0; i<numRows-1; i++){
   textAlign(CENTER); 
   fill(20);
   text(title[i],dewey[i],transCheckouts[i],-copies[i]*5);
  }
  
  //labels
  fill(0);
  pushMatrix();
  textFont(font,12);
  textAlign(LEFT);
  rotate(PI/2);
  for(int i=0;i<10;i++){
    text(deweyType[9-i],1100,100*i-950);
  }
  popMatrix();
  
  textAlign(RIGHT);
  for(int i=0;i<10;i++){
    text(500*i,0,20+110*i);
  }
 
  gui();
}


void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  //countries.draw();
  for(int i=0;i<6;i++){
    textAlign(LEFT);
    if(i == 0){
      fill(0);
      text("America", width-75, 33+i*25);
      fill(#050FB4,80);
      rect(width-100,20+i*25,20,20);
    }
    if(i == 1){
      fill(0);
      text("China", width-75, 33+i*25);
      fill(#A52B2B,80);
      rect(width-100,20+i*25,20,20);
    }
    if(i == 2){
      fill(0);
      text("Germany", width-75, 33+i*25);
      fill(#EAE76F,80);
      rect(width-100,20+i*25,20,20);
    }
    if(i == 3){
      fill(0);
      text("India", width-75, 33+i*25);
      fill(#DE8714,80);
      rect(width-100,20+i*25,20,20);
    }
    if(i == 4){
      fill(0);
      text("Korea", width-75, 33+i*25);
      fill(#9A14DE,80);
      rect(width-100,20+i*25,20,20);
    }
    if(i == 5){
      fill(0);
      text("Mexico", width-75, 33+i*25);
      fill(#0A8B2D,80);
      rect(width-100,20+i*25,20,20);
    }
  }
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

//void controlEvent(ControlEvent theEvent) {
//  if (theEvent.isFrom(countries)) {
//    myColorBackground = 0;
//    print("got an event from "+checkbox.getName()+"\t\n");
//    // checkbox uses arrayValue to store the state of 
//    // individual checkbox-items. usage:
//    println(checkbox.getArrayValue());
//    int col = 0;
//    for (int i=0;i<checkbox.getArrayValue().length;i++) {
//      int n = (int)checkbox.getArrayValue()[i];
//      print(n);
//      if(n==1) {
//        myColorBackground += checkbox.getItem(i).internalValue();
//      }
//    }
//    println();    
//  }
//}
//
//void countries(float[] a) {
//  println(a);
//}

void keyPressed(){
  if(key == 's'){
    saveFrame("screens/screen-#####.png");
  }
}
